//------------------------------------------------------------------------------
// Lamp : Open source game middleware
// Copyright (C) 2004  Junpei Ohtani ( Email : junpee@users.sourceforge.jp )
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

/** @file
 * アンズジャンプ状態実装
 * @author Junpee
 */

#include "Core/Utility/stdafx.h"
#include "Player/Anzu/AnzuJumpState.h"
#include "Game/Sound/SoundSystem.h"
#include "Player/System/Player.h"
#include "Stage/System/Stage.h"

#include "Player/Anzu/AnzuStandState.h"
#include "Player/Anzu/AnzuRunState.h"
#include "Player/Anzu/AnzuJumpAttackState.h"

//------------------------------------------------------------------------------
// 生成、破棄
//------------------------------------------------------------------------------
// コンストラクタ
AnzuJumpState::AnzuJumpState(Anzu* anzu, bool doubleJump) :
	AnzuState(anzu), isDoubleJump_(doubleJump){
}
//------------------------------------------------------------------------------
// デストラクタ
AnzuJumpState::~AnzuJumpState(){
}
//------------------------------------------------------------------------------
// 実行
//------------------------------------------------------------------------------
// 初期化
void AnzuJumpState::initialize(){
	// アニメーションシーケンス設定
	getAnimation()->setSequence(6);
	// ジャンプ速度設定
	float jumpVelocity = 3.f;
	setVelocity(getVelocity() + Vector3(0.f, jumpVelocity, 0.f));
	setAerial(true);
	// ジャンプ音を鳴らす
	getSoundSystem()->play("AnzuJump");
}
//------------------------------------------------------------------------------
// 後始末
void AnzuJumpState::finalize(){
}
//------------------------------------------------------------------------------
// 実行
void AnzuJumpState::run(){
	// 定数
	float animationScale = 1.f;
	float moveXZScale = 0.5f;

	// ステート変更
	Point2f moveStick = getMoveStick();
	if(!isDamaged()){
		if(!isAerial()){
			if(moveStick == Point2f::zero){
				getPlayer()->setState(new AnzuStandState(getAnzu()));
			}else{
				getPlayer()->setState(new AnzuRunState(getAnzu()));
			}
		}else if(downAttackButton()){
			getPlayer()->setState(
				new AnzuJumpAttackState(getAnzu(), isDoubleJump_));
		}else if(downJumpButton() && (!isDoubleJump_)){
			getPlayer()->setState(new AnzuJumpState(getAnzu(), true));
		}
	}

	// 移動ベクトル算出
	Vector3 moveVelocity(moveStick.x, 0.f, moveStick.y);
	moveVelocity *= moveXZScale;

	// 位置と速度の計算
	calcVelocityAndPosition(moveVelocity);
	// 向きの設定
	setDirection(moveVelocity);

	// 地形コリジョン
	landCollide();

	// 描画セットアップ
	drawSetup(animationScale);
}
//------------------------------------------------------------------------------
